<%@ LANGUAGE=JScript %>
<%

  Response.ContentType = "text/xml";
  
  if( Application("serverServer") == void 0 )
  {
  
    Application.Lock();
    if( Application("serverServer") == void 0 )
    {
    
      var SoapServer;
      var WSDLFilePath;
      var WSMLFilePath;
      
      WSDLFilePath = Server.MapPath("SERVER.WSDL");
      WSMLFilePath = Server.MapPath("SERVER.WSML");
      
      try
      {
        SoapServer = Server.CreateObject("MSSOAP.SoapServer30");
      }
      catch(err)
      {
        SendFault("Cannot create SoapServer object. " + err.description + " (" + err.number + ")");
      }
    
      try
      {
        SoapServer.Init(WSDLFilePath, WSMLFilePath);
      }
      catch(err)
      {
        SendFault("SoapServer.Init failed. " & err.description);
      }
    
      Application("serverServer") = SoapServer;
      
    }
    Application.UnLock();
    
  }

  SoapServer = Application("serverServer");
  
  try
  {
    SoapServer.SoapInvoke(Request, Response, "");
  }
  catch(err)
  {
    SendFault("SoapServer.SoapInvoke failed. " & err.description);
  }
  
  function SendFault(LogMessage)
  {
    
    var Serializer;
    
    // "URI Query" logging must be enabled for AppendToLog to work
    
    Response.AppendToLog(" SOAP ERROR: " & LogMessage);
    
    try
    {
      Serializer = Server.CreateObject("MSSOAP.SoapSerializer30");
    }
    catch(err)
    {  
      Response.AppendToLog("Could not create SoapSerializer object. " & err.description);
      Response.Status = "500 Internal Server Error";
      Response.End();
    }

    try
    {    
      Serializer.Init(Response);
    }
    catch(err)
    {
      Response.AppendToLog("SoapSerializer.Init failed. " & err.description);
      Response.Status = "500 Internal Server Error";
      Response.End();
    }

    try
    {      
      Serializer.startEnvelope("", "", "");
      Serializer.startBody("");
      Serializer.startFault("Server", "The request could not be processed due to a problem in the server. Please contact the system admistrator. " + LogMessage, "");
      Serializer.endFault();
      Serializer.endBody();
      Serializer.endEnvelope();
    }
    catch(err)
    {
      Response.AppendToLog("SoapSerializer failed. " & err.description);
      Response.Status = "500 Internal Server Error";
      Response.End();
    }          
      
    Response.End();
    
  }  
  
%>